-java package should not recommend -java-gcj counterpart on all architectures

Bug #386307 reported by Thierry Carrez
6
This bug affects 1 person
Affects Status Importance Assigned to Milestone
antlr (Ubuntu)
Fix Released
Medium
Thierry Carrez
antlr3 (Ubuntu)
Fix Released
Medium
Thierry Carrez
bouncycastle (Ubuntu)
Fix Released
Medium
Thierry Carrez
jakarta-log4j (Ubuntu)
Fix Released
Medium
Thierry Carrez
libjaxp1.3-java (Ubuntu)
Fix Released
Medium
Thierry Carrez
libxalan2-java (Ubuntu)
Fix Released
Medium
Thierry Carrez
libxerces2-java (Ubuntu)
Fix Released
Medium
Thierry Carrez

Bug Description

libbcprov-java currently recommends libbcprov-java-gcj, which results in pulling the full GCJ environment on systems which don't need it (i386, amd64...) whenever you depend on libbcprov-java. This will result in oversized Server CD when eucalyptus will be present on CD.

Revision history for this message
Thierry Carrez (ttx) wrote :

After discussion with cjwatson and doko, using the seed "blacklist" features isn't a viable option to keep GCJ away from the Server CD. The good way of doing things is to use arch-conditional recommends to pull it only on architectures which heavily benefit from using GCJ.

However for "all" builds, using arch-conditional recommends currently doesn't work (they get evaluated only once) so we also need to make libbcprov-java a "any" build. The trade-off in size/build-time is acceptable for a library like bouncycastle.

Changed in bouncycastle (Ubuntu):
assignee: nobody → Thierry Carrez (ttx)
importance: Undecided → Medium
status: New → Triaged
Thierry Carrez (ttx)
Changed in bouncycastle (Ubuntu):
status: Triaged → In Progress
Revision history for this message
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package bouncycastle - 1.39-2ubuntu3

---------------
bouncycastle (1.39-2ubuntu3) karmic; urgency=low

  * debian/control: Use -headless JRE dependencies (LP: #387884, #337842)
  * debian/control: Only suggest libbcprov-java-gcj on selected architectures,
    build libbcprov-java architecture "any" to have it work (LP: #386307)

 -- Thierry Carrez <email address hidden> Fri, 03 Jul 2009 13:55:51 +0200

Changed in bouncycastle (Ubuntu):
status: In Progress → Fix Released
Thierry Carrez (ttx)
summary: - libbcprov-java should not recommend libbcprov-java-gcj on all
+ -java package should not recommend -java-gcj counterpart on all
architectures
Changed in jakarta-log4j (Ubuntu):
assignee: nobody → Thierry Carrez (ttx)
importance: Undecided → Medium
status: New → In Progress
Revision history for this message
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package jakarta-log4j - 1.2.15-4ubuntu1

---------------
jakarta-log4j (1.2.15-4ubuntu1) karmic; urgency=low

  * debian/control: Only suggest -java-gcj on selected architectures, and
    build liblog4j1.2-java architecture "any" to have it work (LP: #386307)

 -- Thierry Carrez <email address hidden> Fri, 24 Jul 2009 14:36:12 +0200

Changed in jakarta-log4j (Ubuntu):
status: In Progress → Fix Released
Thierry Carrez (ttx)
Changed in antlr3 (Ubuntu):
assignee: nobody → Thierry Carrez (ttx)
importance: Undecided → Medium
status: New → In Progress
Revision history for this message
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package antlr3 - 3.0.1+dfsg-4ubuntu1

---------------
antlr3 (3.0.1+dfsg-4ubuntu1) karmic; urgency=low

  * debian/control: Only suggest antlr3-gcj on selected architectures, and
    build antlr3 architecture "any" to have it work (LP: #386307)
  * debian/control: Runtime depend on java2-runtime-headless rather than
    java2-runtime.

 -- Thierry Carrez <email address hidden> Fri, 14 Aug 2009 13:24:25 +0200

Changed in antlr3 (Ubuntu):
status: In Progress → Fix Released
Thierry Carrez (ttx)
Changed in libjaxp1.3-java (Ubuntu):
assignee: nobody → Thierry Carrez (ttx)
importance: Undecided → Medium
status: New → In Progress
Changed in libxalan2-java (Ubuntu):
assignee: nobody → Thierry Carrez (ttx)
importance: Undecided → Medium
status: New → In Progress
Revision history for this message
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package libjaxp1.3-java - 1.3.04-3ubuntu3

---------------
libjaxp1.3-java (1.3.04-3ubuntu3) karmic; urgency=low

  * debian/control: Only suggest -gcj on selected architectures, and
    build libjaxp1.3-java architecture "any" to have it work (LP: #386307)

 -- Thierry Carrez <email address hidden> Fri, 14 Aug 2009 13:42:09 +0200

Changed in libjaxp1.3-java (Ubuntu):
status: In Progress → Fix Released
Thierry Carrez (ttx)
Changed in libxerces2-java (Ubuntu):
assignee: nobody → Thierry Carrez (ttx)
importance: Undecided → Medium
status: New → In Progress
Revision history for this message
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package libxalan2-java - 2.7.1-2ubuntu1

---------------
libxalan2-java (2.7.1-2ubuntu1) karmic; urgency=low

  * debian/control: Only suggest libxalan2-java-gcj on selected architectures,
    and libxalan2-java architecture "any" to have it work (LP: #386307)

 -- Thierry Carrez <email address hidden> Fri, 14 Aug 2009 13:48:55 +0200

Changed in libxalan2-java (Ubuntu):
status: In Progress → Fix Released
Thierry Carrez (ttx)
Changed in antlr (Ubuntu):
assignee: nobody → Thierry Carrez (ttx)
importance: Undecided → Medium
status: New → In Progress
Revision history for this message
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package libxerces2-java - 2.9.1-2ubuntu3

---------------
libxerces2-java (2.9.1-2ubuntu3) karmic; urgency=low

  * debian/control: Only suggest -gcj on selected architectures, and
    build libxerces2-java architecture "any" to have it work (LP: #386307)

 -- Thierry Carrez <email address hidden> Fri, 14 Aug 2009 13:58:16 +0200

Changed in libxerces2-java (Ubuntu):
status: In Progress → Fix Released
Revision history for this message
Thierry Carrez (ttx) wrote :

For antlr we can't play the "any" trick since it triggers not-binnmuable-all-depends-any between antlr and libantlr-java. So I arch-unconditionally suggest libantlr-java-gcj instead.

Changed in antlr (Ubuntu):
status: In Progress → Fix Committed
Revision history for this message
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package antlr - 2.7.7-11ubuntu1

---------------
antlr (2.7.7-11ubuntu1) karmic; urgency=low

  * debian/control: Make libantlr-java only suggest libantlr-java-gcj
    (LP: #386307)

 -- Thierry Carrez <email address hidden> Fri, 14 Aug 2009 14:05:41 +0200

Changed in antlr (Ubuntu):
status: Fix Committed → Fix Released
Revision history for this message
Thierry Carrez (ttx) wrote :

For libxerces2-java the arch:any trick doesn't really work since it build-depends on ant, which depends on libxerces2-java. Unavaibility of libxerces2-java on certain archs causes FTBFS for most Java packages on those archs. So for this specific case I'll restore the arch:all build and downgrade the -gcj recommend to a suggests, pending a better solution.

Changed in libxerces2-java (Ubuntu):
status: Fix Released → In Progress
Revision history for this message
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package libxerces2-java - 2.9.1-2ubuntu4

---------------
libxerces2-java (2.9.1-2ubuntu4) karmic; urgency=low

  * debian/control: Fix FTBFS on certain archs by reverting previous change
    and suggest the -gcj package on all archs (rather than trying to recommend
    it on a few) (LP: #386307)

 -- Thierry Carrez <email address hidden> Tue, 18 Aug 2009 11:47:48 +0200

Changed in libxerces2-java (Ubuntu):
status: In Progress → Fix Released
Revision history for this message
Alvin Thompson (alvint-deactivatedaccount) wrote :

can we add 'ant' and 'ant-optional' to this list?

Revision history for this message
Alvin Thompson (alvint-deactivatedaccount) wrote :

also, 'libitext-java' would be nice since it's needed by Maven. here are others that i'm aware of:

(canonical)
libdb4.6-java
libdb4.7-java
libsac-java
libsxltc-java

(universe)
libaxis-java
libbcmail-java
libbcpg-java
libbctsp-java
libitext-java
libswt3.2-gtk-java

Revision history for this message
Thierry Carrez (ttx) wrote :

Alvin:
The rationale for those packages is slightly different, since not fixing it will not result in a oversized server CD, which makes those a lot less critical.

In particular, the trick I've been mostly using (building the package for any architecture, rather than once for "all") is costly in terms of resources, so we wanted to limit it to a few key packages. However this question might be revisited for next release as we move to JIT capabilities on alternate archs, and then using "Suggests" will have no downside.

I'd suggest opening another bug to track the remaining ones (with one package task for each source package, using "Also affects distribution...")

Thanks !

Revision history for this message
Alvin Thompson (alvint-deactivatedaccount) wrote :

yup, i created separate bugs for the ones that Maven depends on, at least. :)

To post a comment you must log in.
This report contains Public information  
Everyone can see this information.

Other bug subscribers